package com.hzs.system.sys.mapper;

import com.hzs.common.domain.system.sys.SysRole;
import com.hzs.common.domain.system.sys.SysUser;
import com.hzs.system.sys.param.SysUserQueryParam;
import com.hzs.system.sys.vo.SysRoleUserVO;
import com.hzs.system.sys.vo.SysUserQueryVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 用户表 数据层
 *
 * @author hzs
 */
public interface SysUserMapper {

    /**
     * 根据条件分页查询用户列表
     *
     * @param param
     * @return
     */
    List<SysUserQueryVO> selectUserList(@Param("param") SysUserQueryParam param);

    /**
     * 通过用户名查询用户
     *
     * @param userName 用户名
     * @return 用户对象信息
     */
    SysUser selectUserByUserName(String userName);

    /**
     * 通过用户ID查询用户
     *
     * @param userId 用户ID
     * @return 用户对象信息
     */
    SysUser selectUserById(Long userId);

    /**
     * 新增用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    int insertUser(SysUser user);

    /**
     * 修改用户信息
     *
     * @param user 用户信息
     * @return 结果
     */
    int updateUser(SysUser user);

    /**
     * 重置用户密码
     *
     * @param userName 用户名
     * @param password 密码
     * @return 结果
     */
    int resetUserPwd(@Param("userName") String userName, @Param("password") String password);

    /**
     * 批量删除用户信息
     *
     * @param userIds 需要删除的用户ID
     * @param userId  用户ID
     * @return 结果
     */
    int deleteUserByIds(@Param("userIds") Long[] userIds, @Param("userId") Long userId, @Param("userType") Integer userType);

    /**
     * 校验用户名称是否唯一
     *
     * @param userName 用户名称
     * @return 结果
     */
    int checkUserNameUnique(String userName);

    /**
     * 校验手机号码是否唯一
     *
     * @param phonenumber 手机号码
     * @return 结果
     */
    SysUser checkPhoneUnique(String phonenumber);

    /**
     * 根据角色ID查询用户
     *
     * @param roleId
     * @return
     */
    List<SysRoleUserVO> queryUserByRoleId(@Param("roleId") Long roleId);

    /**
     * 查询会员以及部门名称
     *
     * @param userId   用户ID
     * @return
     */
    SysUser queryUserAndDeptName(@Param("userId") Long userId);

    /**
     * 查询角色用户信息
     *
     * @return List<SysRole>
     */
    List<SysRole> selectSysUserRole(@Param("pkCountry") Integer pkCountry);

    /**
     * 查询全部管理员
     *
     * @return
     */
    List<SysUser> selectAll();

    /**
     * 更新最新系统类型
     *
     * @param userId     会员ID
     * @param systemType 系统类型
     * @return
     */
    int updateLastSystemType(@Param("userId") Long userId, @Param("systemType") Integer systemType);

}
